Subject: Re: bug#32749: package-with-explicit-inputs leaks-in additional inputs

From: Jan Nieuwenhuizen <[email-masked]>
Date: Mon, 17 Sep 2018 17:59:54 +0200

Jan Nieuwenhuizen writes:

> Should `package-with-explicit-inputs' behave like I think it does, i.e.,
> should both test packages list the same dependencies, or am I missing
> something?

Printing the packages in the Guix Repl gives this result

--8<---------------cut here---------------start------------->8---
(package-inputs gnu-make-no-implicit-inputs)
$12 = (("libc" #<package glibc-bootstrap@0 gnu/packages/bootstrap.scm:150 3f39cc0>) ("gcc" #<package gcc-bootstrap@0 gnu/packages/bootstrap.scm:150 3f39c00>) ("binutils" #<package binutils-bootstrap@0 gnu/packages/bootstrap.scm:150 3f39b40>) ("coreutils&co" #<package bootstrap-binaries@0 gnu/packages/bootstrap.scm:150 3f39a80>) ("bash" #<package bootstrap-binaries@0 gnu/packages/bootstrap.scm:150 3f39a80>))
scheme@(gnu packages pawei)> (map car (package-inputs gnu-make-no-implicit-inputs))
$13 = ("libc" "gcc" "binutils" "coreutils&co" "bash")
scheme@(gnu packages pawei)> (package-native-inputs gnu-make-no-implicit-inputs)
$14 = ()
scheme@(gnu packages pawei)> (package-propagated-inputs gnu-make-no-implicit-inputs)
$15 = ()
scheme@(gnu packages pawei)> (package-inputs gnu-make-explicit-inputs)
$16 = (("libc" #<package glibc-bootstrap@0 gnu/packages/bootstrap.scm:150 3f39cc0>) ("gcc" #<package gcc-bootstrap@0 gnu/packages/bootstrap.scm:150 3f39c00>) ("binutils" #<package binutils-bootstrap@0 gnu/packages/bootstrap.scm:150 3f39b40>) ("coreutils&co" #<package bootstrap-binaries@0 gnu/packages/bootstrap.scm:150 3f39a80>) ("bash" #<package bootstrap-binaries@0 gnu/packages/bootstrap.scm:150 3f39a80>) ("guile" #<package [email-masked] gnu/packages/bootstrap.scm:150 3f39900>))
scheme@(gnu packages pawei)> 
$17 = (("pkg-config" #<package [email-masked] gnu/packages/bootstrap.scm:150 3f39780>))
scheme@(gnu packages pawei)> (package-propagated-inputs gnu-make-explicit-inputs)
$18 = ()
scheme@(gnu packages pawei)> (package-native-inputs gnu-make-explicit-inputs)
$19 = (("pkg-config" #<package [email-masked] gnu/packages/bootstrap.scm:150 3f39780>))
--8<---------------cut here---------------end--------------->8---

which is exactly what I expect to see when I read the Guile code for the
package descriptions; but is still a bit surprising to me: where do all
the extra inputs come from in the graph?

janneke